import graphql from '@rollup/plugin-graphql';
import image from '@rollup/plugin-image';
import typescript from '@rollup/plugin-typescript';
import { string } from 'rollup-plugin-string';

// Define a base configuration for reuse
const baseConfig = {
  plugins: [
    image(),
    graphql({
      include: '**/*.gql',
    }),
    string({
      include: '**/*.graphql',
    }),
    typescript({ noEmitOnError: true }),
  ],
  // marking all node modules as external
  external: (id) => !/^[./]/.test(id),
};

// Configuration for index.ts
const indexConfig = {
  ...baseConfig,
  input: 'src/index.ts',
  output: [
    {
      dir: 'lib',
      format: 'es',
      name: 'FrontendStackReact',
      compact: true,
      exports: 'named',
      sourcemap: false,
      preserveModules: true,
      chunkFileNames: 'index-[hash].[format].js',
      globals: baseConfig.globals,
    },
  ],
};

export default [indexConfig];
